"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.lodashOptimizeImports = lodashOptimizeImports;
const fs_1 = __importDefault(require("fs"));
const acorn = __importStar(require("acorn"));
const transform_1 = require("@optimize-lodash/transform");
const acorn_typescript_1 = require("acorn-typescript");
const wrappedParse = (code) => acorn.parse(code, {
    ecmaVersion: "latest",
    sourceType: "module",
    locations: true,
});
const wrappedTypescriptParse = (code) => 
// @ts-expect-error type issues, probably due to differing acorn versions
acorn.Parser.extend((0, acorn_typescript_1.tsPlugin)()).parse(code, {
    ecmaVersion: "latest",
    sourceType: "module",
    locations: true,
});
const selectLoader = (path) => {
    const extension = path.split(".").at(-1);
    switch (extension) {
        case "mts":
        case "ts": {
            return "ts";
        }
        case "tsx": {
            return "tsx";
        }
        case "mjs":
        case "js": {
            return "js";
        }
        case "jsx": {
            return "jsx";
        }
        default: {
            throw new Error(`Unexpected extension: ${extension}`);
        }
    }
};
// eslint-disable-next-line unicorn/prefer-set-has -- faster than Set for a small number of items
const TS_EXTENSIONS = ["ts", "tsx", "mts"];
const isTypescriptPath = (path) => TS_EXTENSIONS.includes(path.split(".").at(-1));
// TODO: filter https://golang.org/pkg/regexp/
function lodashOptimizeImports({ useLodashEs, appendDotJs = true, } = {}) {
    const cache = new Map();
    return {
        name: "lodash-optimize-imports",
        setup(build) {
            build.onLoad({ filter: /\.(mjs|mts|js|ts|jsx|tsx)$/ }, async ({ path }) => {
                const input = await fs_1.default.promises.readFile(path, "utf8");
                const cached = cache.get(path); // TODO: unit test the cache
                // the input hasn't changed since we last processed it + we have a cached result
                if (cached && input === cached.input) {
                    return cached.output === transform_1.UNCHANGED
                        ? undefined
                        : { contents: cached.output, loader: cached.loader };
                }
                const result = (0, transform_1.transform)({
                    code: input,
                    id: path,
                    // acorn is far more battle-tested than acorn-typescript,
                    // so we only use acorn-typescript when we have to
                    parse: isTypescriptPath(path)
                        ? wrappedTypescriptParse
                        : wrappedParse,
                    useLodashEs,
                    appendDotJs,
                });
                if (result === transform_1.UNCHANGED) {
                    cache.set(path, { input, output: transform_1.UNCHANGED });
                    return;
                }
                const output = result.code;
                const loader = selectLoader(path);
                cache.set(path, { input, output, loader });
                return { contents: output, loader };
            });
        },
    };
}
//# sourceMappingURL=index.js.map